#include "../ssa/build_ssa.hpp"
#include "cdg.hpp"
namespace ssa{

//simple constant propagation
class DeadcodeElimination{
public:
    DeadcodeElimination(NodeList* nodelist):nodelist(nodelist){
        cdg = new ControlDependenceGraph(nodelist, nullptr);
    }
    void eliminate();
    void mask();
    bool has_side_effect(mir::Stm* stm);
    NodeList* nodelist;
    ControlDependenceGraph* cdg;
    std::unordered_map<utils::Temp*, mir::Stm*> def_stm;
    std::unordered_map<mir::Stm*, Node*> stm_to_block;
    std::set<mir::Stm*> active_stm;
    std::set<Node*> active_block;
    std::set<mir::Stm*> worklist;
};

}//namespace ssa