#include "fi.hpp"
namespace mir{

bool is_call(Stm* stm){
    if(stm->kind == StmType::MOVE){
        auto movstm = static_cast<Move*>(stm);
        if(movstm->src->kind == ExpType::CALL){
            return true;
        }
    }
    if(stm->kind == StmType::EXP){
        auto expstm = static_cast<ExpStm*>(stm);
        if(expstm->exp->kind == ExpType::CALL){
            return true;
        }
    }
    return false;
}
void FunctionInline::fun_analysis(){
    for(auto fun_map: func_infos){
        auto fun_info = fun_map.second;
        auto fun_ir = fun_info->ir;
        for(auto stm: *fun_ir){
            if(is_call(stm)){
                fun_info->called_num++;
            }
        }

    }
};

};