#include "mir.hpp"
namespace mir{

class Func_Info;

class FunctionInline{
public:
    FunctionInline(UnitList* unitlist){
        for(auto& u: *unitlist){
            if(u->kind == mir::UnitType::FUN){
                auto fun = static_cast<mir::Fun*>(u);
                fun->stm = fun->stm->stm_deepcopy();
                fun->stm->fix(true);
                fun->stm->fix(false);
                // fun->print();
                fun->stm->flatten();
                // fun->print();
                auto sl = canon::linearize(fun->stm);
                func_infos[*fun->name] = new Func_Info(fun, sl);
                funcs.push_back(*fun->name);
            }
        }
        fun_analysis();
        fun_inline();
    }
    void fun_analysis();
    void fun_inline();
    std::unordered_map<std::string, Func_Info*> func_infos;
    std::vector<std::string> funcs;
};

class Func_Info{
public:
    Func_Info(Fun* fun, StmList* ir)
    :fun(fun)
    ,ir(ir){
        stksize = fun->args->size();
        called_num = 0;
    };
    int stksize;
    int called_num;
    Fun* fun;
    StmList* ir;
};

}