#pragma once
#include "domi.hpp"
#include "../../utils/temp.hpp"
#include "../cfg/bg.hpp"
#include <stack>
namespace ssa{

using DomiTable = std::unordered_map<Node*, Node_Dominance*>;
using TempDefTable = std::unordered_map<Node*, std::set<utils::Temp*>>;
using TempSites = std::unordered_map<utils::Temp*, NodeList>;
using TempStack = std::unordered_map<utils::Temp*, std::stack<utils::Temp*>>;
class Ssa{
    public:
    Ssa(NodeList* nodelist, utils::TempList* fun_args)
    :nodelist(nodelist)
    ,fun_args(fun_args){
        //printf("****compute domi****\n");
        domi_table = compute_domi(nodelist);
        //printf("****get origin def****\n");
        for(auto& node: *nodelist){
            get_origin_def(node);
        }
    
        //printf("****place phi****\n");
        place_phi();
        auto node = nodelist->front();
        auto graph = static_cast<cfg::BlockGraph*>(node->mygraph);
        //graph->show();

        //printf("****rename****\n");
        rename();
    }
    utils::TempList* get_origin_def(Node* n);
    void place_phi();
    void rename();
    void rename_single_node(Node* n);
    NodeList* back_to_ir();
    void remove_empty();
    utils::TempList* fun_args;
    NodeList* nodelist;
    DomiTable domi_table;
    TempDefTable origin_defs;
    TempSites defsites;
    std::set<utils::Temp*> usesites;
    TempStack stacks;
    std::set<Node*> done;
};

mir::Exp* get_def(mir::Stm* stm);
mir::ExpList get_uses(mir::Stm* stm);   
}
