#include "domi.hpp"

namespace ssa{

void Node_Dominance_Calculator::show_dominator(NodeList* nodelist){
    //std::cout << "dominators:"<<std::endl;
    for(auto n: *nodelist){
            //std::cout << n->mykey<< ":";
            for(auto node: domi_table[n]->dominator){
            //std::cout << node->mykey<< ",";
        }
        //std::cout << std::endl;
        }
        
}
void Node_Dominance_Calculator::show_dominance_frontier(NodeList* nodelist){
    //std::cout << "dominance frontier:"<<std::endl;
    for(auto& domi: domi_table){
            //std::cout<< domi.first->mykey << ": ";
            for(auto df: domi.second->dominance_frontier){
                //std::cout<< df->mykey << ",";
            };
            //std::cout << std::endl;
        }
}
void Node_Dominance_Calculator::update_dominator(Node* n, NodeSet* preds){
    std::set<Node*> com,cur_com;
    for(auto& pred: *preds){
        auto pred_dom = domi_table[pred];
        cur_com.clear();
        if(pred == *preds->begin()) com = pred_dom->dominator;
        else{
            for(auto p: pred_dom->dominator){
                if(com.count(p) > 0) cur_com.insert(p);
            }
            com = cur_com;
        }
        
    }
    com.insert(n);
    if(com == domi_table[n]->dominator) {
    }
    else {
        changedflag = true;
    }
    domi_table[n]->dominator = com;
}

void Node_Dominance_Calculator::find_dominator(NodeList* nodelist){
    NodeList* iter_nodelist = nodelist;
    changedflag = true;
    while(changedflag){
        changedflag = false;
        for(auto& node: *nodelist){
            if(domi_table.count(node) == 0){
                domi_table[node] = new Node_Dominance(node, nodelist);
            }
        }
        for(auto& node: *nodelist){
            NodeSet* preds = node->preds;
            update_dominator(node, preds);
            // show_dominator(nodelist);
        }
    }
}

void Node_Dominance_Calculator::get_dominance_frontier(NodeList* nodelist){
    for(auto& nodew: *nodelist){
            auto w_dom = domi_table[nodew]->dominator;
            NodeSet* w_preds = nodew->preds;
            for(auto& nodep: *w_preds){
                auto p_dom = domi_table[nodep]->dominator;
                for(auto& nodex: p_dom){
                    if(nodex == nodew || w_dom.count(nodex) == 0){
                        domi_table[nodex]->dominance_frontier.insert(nodew);
                    }
                }
        }
    }
}

std::unordered_map<Node*, Node_Dominance*> compute_domi(NodeList* nodelist){
    auto domi_cal = Node_Dominance_Calculator();
    domi_cal.find_dominator(nodelist);
    // domi_cal.show_dominator(nodelist);
    domi_cal.get_dominance_frontier(nodelist);
    // domi_cal.show_dominance_frontier(nodelist);
    return domi_cal.domi_table;
}

}//namespace domi
