#pragma once
#include <iostream>
#include <unordered_map>
#include <set>
#include "../cfg/graph.hpp"
#include <algorithm>
namespace ssa {
using namespace cfg;



class Node_Dominance{
public:
    Node_Dominance(Node* n, NodeList* nodelist):n(n){
        if(n == nodelist->front()){
            dominator.insert(n);
        }else{
            for(auto node: *nodelist) dominator.insert(node);
        }
    };
    Node* n;
    std::set<Node*> dominator;
    std::set<Node*> dominance_frontier;
    NodeList* dominated_list;
};
class Node_Dominance_Calculator{
public:
    bool changedflag;
    std::unordered_map<Node*, Node_Dominance*> domi_table;
    void update_dominator(Node* n, NodeSet* preds);
    void find_dominator(NodeList* nodelist);
    void get_dominance_frontier(NodeList* nodelist);
    void show_dominator(NodeList* nodelist);
    void show_dominance_frontier(NodeList* nodelist);
};

std::unordered_map<Node*, Node_Dominance*> compute_domi(NodeList* nodelist);
};